CREATE TABLE IF NOT EXISTS `TAT_ACCOUNT_DATA` (
  `ACCOUNT_DATA_ID` int(11) NOT NULL AUTO_INCREMENT,
  `SUBJECT_ID` int(11) NOT NULL,
  `ACCOUNT_NAME` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  `ACCOUNT_PASSWORD` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  `ACCOUNT_FOLDER` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  `PROPERTY_NAME` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  `PROPERTY_VALUE` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  `INSERT_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `UPDATE_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`ACCOUNT_DATA_ID`),
  KEY `tat_account_data_subject_idx01` (`SUBJECT_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_CODE` (
  `CODE_ID` int(11) NOT NULL AUTO_INCREMENT,
  `INSERT_DT` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`CODE_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `TAT_GROUP` (
  `GROUP_ID` int(11) NOT NULL AUTO_INCREMENT,
  `STUDY_ID` int(11) NOT NULL,
  `GROUP_NR` int(11) NOT NULL,
  `GROUP_NAME` varchar(50) COLLATE latin1_german1_ci NOT NULL,
  `GROUP_TYPE_CD` decimal(5,0) NOT NULL,
  PRIMARY KEY (`GROUP_ID`),
  KEY `tat_group_study_idx01` (`STUDY_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_GROUP_MODULE` (
  `GROUP_MODULE_ID` int(11) NOT NULL AUTO_INCREMENT,
  `GROUP_ID` int(11) NOT NULL,
  `MODULE_ID` int(11) NOT NULL,
  `XML_FILE` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  `JNLP_FILE` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  PRIMARY KEY (`GROUP_MODULE_ID`),
  KEY `tat_group_module_group_idx01` (`GROUP_ID`),
  KEY `tat_group_module_module_idx02` (`MODULE_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_MODULE` (
  `MODULE_ID` int(11) NOT NULL AUTO_INCREMENT,
  `STUDY_ID` int(11) NOT NULL,
  `MODULE_NR` int(11) NOT NULL,
  `MODULE_NAME` varchar(50) COLLATE latin1_german1_ci NOT NULL,
  `MODULE_TYPE_CD` decimal(5,0) NOT NULL,
  `LIMIT_DOWN_NUM` int(11) NOT NULL,
  `LIMIT_SESS_NUM` int(11) NOT NULL,
  PRIMARY KEY (`MODULE_ID`),
  KEY `tat_module_study_idx01` (`STUDY_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_MODULE_DATA` (
  `MODULE_DATA_ID` int(11) NOT NULL AUTO_INCREMENT,
  `MODULE_ID` int(11) NOT NULL,
  `GROUP_ID` int(11) NOT NULL,
  `SUBJECT_ID` int(11) NOT NULL,
  `UNIT_ID` varchar(250) CHARACTER SET latin1 NOT NULL,
  `PROPERTY_NAME` varchar(250) CHARACTER SET latin1 NOT NULL,
  `PROPERTY_VALUE` varchar(250) CHARACTER SET latin1 NOT NULL,
  `INSERT_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `UPDATE_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`MODULE_DATA_ID`),
  KEY `tat_module_date_module_group_subject_unit_idx01` (`MODULE_ID`,`GROUP_ID`,`SUBJECT_ID`,`UNIT_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_MODULE_STUDY` (
  `MODULE_STUDY_ID` int(11) NOT NULL AUTO_INCREMENT,
  `MODULE_ID` int(11) NOT NULL,
  `STUDY_ID` int(11) NOT NULL,
  PRIMARY KEY (`MODULE_STUDY_ID`),
  KEY `tat_module_study_study_module_idx01` (`STUDY_ID`,`MODULE_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_SESSION` (
  `SESSION_ID` int(11) NOT NULL AUTO_INCREMENT,
  `MODULE_ID` int(11) NOT NULL,
  `GROUP_ID` int(11) NOT NULL,
  `SUBJECT_ID` int(11) NOT NULL,
  `FILE_PREFIX` varchar(50) COLLATE latin1_german1_ci NOT NULL,
  `SESS_ID` int(11) NOT NULL,
  `SESS_START_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `SESS_END_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `INSERT_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`SESSION_ID`),
  KEY `tat_session_module_idx01` (`MODULE_ID`),
  KEY `tat_session_group_idx02` (`GROUP_ID`),
  KEY `tat_session_subject_module_idx03` (`SUBJECT_ID`,`MODULE_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_SESSION_DATA` (
  `SESSION_DATA_ID` int(11) NOT NULL AUTO_INCREMENT,
  `SESSION_ID` int(11) NOT NULL,
  `UNIT_ID` varchar(250) CHARACTER SET latin1 NOT NULL,
  `PROPERTY_NAME` varchar(250) CHARACTER SET latin1 NOT NULL,
  `PROPERTY_VALUE` varchar(250) CHARACTER SET latin1 NOT NULL,
  `INSERT_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`SESSION_DATA_ID`),
  KEY `tat_session_data_idx01` (`SESSION_ID`,`UNIT_ID`,`PROPERTY_NAME`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_STUDY` (
  `STUDY_ID` int(11) NOT NULL AUTO_INCREMENT,
  `STUDY_NAME` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  PRIMARY KEY (`STUDY_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_SUBJECT` (
  `SUBJECT_ID` int(11) NOT NULL AUTO_INCREMENT,
  `STUDY_ID` int(11) NOT NULL,
  `SUBJECT_STATUS_CD` decimal(1,0) NOT NULL,
  `SUBJECT_CODE` varchar(10) COLLATE latin1_german1_ci NOT NULL,
  `SUBJECT_NAME` varchar(50) COLLATE latin1_german1_ci NOT NULL,
  `SUBJECT_MAIL` varchar(50) COLLATE latin1_german1_ci NOT NULL,
  `SUBJECT_PHONE` varchar(50) COLLATE latin1_german1_ci NOT NULL,
  `SUBJECT_SEX_CD` decimal(1,0) NOT NULL,
  `SUBJECT_BIRTH` decimal(4,0) NOT NULL,
  `SUBJECT_EDUCATION` varchar(250) COLLATE latin1_german1_ci NOT NULL,
  PRIMARY KEY (`SUBJECT_ID`),
  KEY `tat_subject_study_subject_idx01` (`STUDY_ID`,`SUBJECT_CODE`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_SUBJECT_GROUP` (
  `SUBJECT_GROUP_ID` int(11) NOT NULL AUTO_INCREMENT,
  `SUBJECT_ID` int(11) NOT NULL,
  `GROUP_ID` int(11) NOT NULL,
  PRIMARY KEY (`SUBJECT_GROUP_ID`),
  KEY `tat_subject_group_subject_group_idx01` (`SUBJECT_ID`,`GROUP_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_SUBJECT_LOG` (
  `SUBJECT_LOG_ID` int(11) NOT NULL AUTO_INCREMENT,
  `STUDY_ID` int(11) NOT NULL,
  `GROUP_ID` int(11) NOT NULL,
  `SUBJECT_ID` int(11) NOT NULL,
  `MODULE_ID` int(11) NOT NULL,
  `LOG_CD` int(11) NOT NULL,
  `INSERT_DT` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`SUBJECT_LOG_ID`),
  KEY `tat_subject_log_study_subject_module_idx01` (`STUDY_ID`,`SUBJECT_ID`,`MODULE_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_SUBJECT_MODULE` (
  `SUBJECT_MODULE_ID` int(11) NOT NULL AUTO_INCREMENT,
  `SUBJECT_ID` int(11) NOT NULL,
  `MODULE_ID` int(11) NOT NULL,
  `STATUS_CD` int(11) NOT NULL,
  PRIMARY KEY (`SUBJECT_MODULE_ID`),
  KEY `tat_subject_module_subject_module_idx01` (`SUBJECT_ID`,`MODULE_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `TAT_USER` (
  `USER_ID` int(11) NOT NULL AUTO_INCREMENT,
  `USER_NAME` varchar(50) COLLATE latin1_german1_ci NOT NULL,
  `USER_PASS` varchar(10) COLLATE latin1_german1_ci NOT NULL,
  `USER_MAIL` varchar(50) COLLATE latin1_german1_ci NOT NULL,
  PRIMARY KEY (`USER_ID`),
  KEY `tat_user_name_idx01` (`USER_NAME`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

CREATE TABLE IF NOT EXISTS `TAT_USER_STUDY` (
  `USER_STUDY_ID` int(11) NOT NULL AUTO_INCREMENT,
  `USER_ID` int(11) NOT NULL,
  `STUDY_ID` int(11) NOT NULL,
  `BLIND_CD` int(11) NOT NULL,
  PRIMARY KEY (`USER_STUDY_ID`),
  KEY `tat_user_study_user_study_idx01` (`USER_ID`,`STUDY_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;
